using Exferia_Aplicacion.General;
using Exferia_Aplicacion.Herencia.Capas;
using Exferia_ControlGastos._0_Modelos;
using Exferia_EntityFramework;
using Exferia_General;
using System;
using System.Collections.Generic;
using System.Data.SqlClient;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Exferia_ControlGastos._1_Datos
{
    public class CTG_OrdenComisionServiciosHospedaje_Datos : ABS_Datos
    {
        #region Listados
        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                         " SELECT " +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "," +
                             nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) +
                        " FROM " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                        " WHERE  " + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + " IS null AND " +
                                     nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<CTG_OrdenComisionServiciosHospedaje>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        public List<INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo> Obtener_PorCabecera(long _lng_idOrdenComisionServicioCabecera)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            List<INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo> lst_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                        " SELECT " +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.id) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.internacional) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.fecha) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.numeroDias) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.establecimiento) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.observaciones) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.precioNoche) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "," +
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.fechaBorrado) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + "," +
                            //ids
                            nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.idOrdenComisionServiciosCabecera) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) +
                       " FROM " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                       " WHERE  " + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + " IS null AND " +
                                    nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) + "=@idOrdenComisionServiciosCabecera ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@idOrdenComisionServiciosCabecera",  _lng_idOrdenComisionServicioCabecera)
                };

                //Rellenar el Modelo
                lst_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Obtener_PorCabecera), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo;
        }
        public INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo Obtener_ParaListado(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo mdl_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                       " SELECT " +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.id) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.internacional) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.fecha) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.numeroDias) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.establecimiento) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.observaciones) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.precioNoche) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "," +
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.fechaBorrado) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + "," +
                           //ids
                           nameof(INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo.idOrdenComisionServiciosCabecera) + "=" + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) +
                      " FROM " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                      " WHERE  " + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + " IS null AND " +
                                   nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                mdl_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo = obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Obtener_ParaListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_CTG_OrdenComisionServiciosHospedaje_Listado_Modelo;
        }
        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTG_OrdenComisionServiciosHospedaje g_mdl_CTG_OrdenComisionServiciosHospedaje = null;

        public CTG_OrdenComisionServiciosHospedaje Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                      //WHERE
                                      " WHERE " + nameof(CTG_OrdenComisionServiciosHospedaje) + "." + nameof(CTG_OrdenComisionServiciosHospedaje.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTG_OrdenComisionServiciosHospedaje;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTG_OrdenComisionServiciosHospedaje = obj_Exferia_Entities.Database.SqlQuery<CTG_OrdenComisionServiciosHospedaje>(_str_SQL, _arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTG_OrdenComisionServiciosHospedaje.id) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "," +
                    nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) +
                " FROM " + nameof(CTG_OrdenComisionServiciosHospedaje);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                CTG_OrdenComisionServiciosHospedaje mdl_CTG_OrdenComisionServiciosHospedaje_AGrabar = (CTG_OrdenComisionServiciosHospedaje)_mdl_obj;
                CTG_OrdenComisionServiciosHospedaje mdl_CTG_OrdenComisionServiciosHospedaje_DatosViejos = new CTG_OrdenComisionServiciosHospedaje();

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosHospedaje mdl_CTG_OrdenComisionServiciosHospedaje_Final = Obtener_Modelo_Por_Id(mdl_CTG_OrdenComisionServiciosHospedaje_AGrabar.id);
                //######################################################################################

                //UPDATE
                if (mdl_CTG_OrdenComisionServiciosHospedaje_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosHospedaje_Final, mdl_CTG_OrdenComisionServiciosHospedaje_DatosViejos, false, false);

                    // Cargar los Datos Nuevos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosHospedaje_AGrabar, mdl_CTG_OrdenComisionServiciosHospedaje_Final, false, false);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                                           " SET " +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) + "=@idOrdenComisionServiciosCabecera," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "=@internacional," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "=@fecha," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "=@numeroDias," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "=@establecimiento," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "=@observaciones," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "=@precioNoche," +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + "=@fechaBorrado" +
                                           " WHERE " +
                                               nameof(CTG_OrdenComisionServiciosHospedaje.id) + "=@id";

                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                         new SqlParameter("@idOrdenComisionServiciosCabecera",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.idOrdenComisionServiciosCabecera),
                         new SqlParameter("@internacional",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.internacional),
                         new SqlParameter("@fecha",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.fecha),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.numeroDias != null
                            ?   new SqlParameter("@numeroDias", mdl_CTG_OrdenComisionServiciosHospedaje_Final.numeroDias.Value)
                            :   new SqlParameter("@numeroDias",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.establecimiento != null
                            ?   new SqlParameter("@establecimiento", mdl_CTG_OrdenComisionServiciosHospedaje_Final.establecimiento)
                            :   new SqlParameter("@establecimiento",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_CTG_OrdenComisionServiciosHospedaje_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.precioNoche != null
                            ?   new SqlParameter("@precioNoche", mdl_CTG_OrdenComisionServiciosHospedaje_Final.precioNoche.Value)
                            :   new SqlParameter("@precioNoche",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosHospedaje_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                         new SqlParameter("@id",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTG_OrdenComisionServiciosHospedaje_Final.id;
                }
                //INSERT
                else
                {
                    mdl_CTG_OrdenComisionServiciosHospedaje_Final = new CTG_OrdenComisionServiciosHospedaje();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    // Cargar los Datos del Modelo
                    Funciones.CopiarPropiedadesObjetos(mdl_CTG_OrdenComisionServiciosHospedaje_AGrabar, mdl_CTG_OrdenComisionServiciosHospedaje_Final, false, false);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                                              " (" +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.idOrdenComisionServiciosCabecera) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.internacional) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.fecha) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.numeroDias) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.establecimiento) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.observaciones) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.precioNoche) + "," +
                                                      nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) +
                                              " ) " +
                                              " OUTPUT INSERTED." + nameof(CTG_OrdenComisionServiciosHospedaje.id) +
                                              " VALUES " +
                                              " ( " +
                                                  "@idOrdenComisionServiciosCabecera," +
                                                  "@internacional," +
                                                  "@fecha," +
                                                  "@numeroDias," +
                                                  "@establecimiento," +
                                                  "@observaciones," +
                                                  "@precioNoche," +
                                                  "@fechaBorrado" +
                                              " ) ";

                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@idOrdenComisionServiciosCabecera",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.idOrdenComisionServiciosCabecera),
                         new SqlParameter("@internacional",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.internacional),
                         new SqlParameter("@fecha",  mdl_CTG_OrdenComisionServiciosHospedaje_Final.fecha),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.numeroDias != null
                            ?   new SqlParameter("@numeroDias", mdl_CTG_OrdenComisionServiciosHospedaje_Final.numeroDias.Value)
                            :   new SqlParameter("@numeroDias",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.establecimiento != null
                            ?   new SqlParameter("@establecimiento", mdl_CTG_OrdenComisionServiciosHospedaje_Final.establecimiento)
                            :   new SqlParameter("@establecimiento",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.observaciones != null
                            ?   new SqlParameter("@observaciones", mdl_CTG_OrdenComisionServiciosHospedaje_Final.observaciones)
                            :   new SqlParameter("@observaciones",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.precioNoche != null
                            ?   new SqlParameter("@precioNoche", mdl_CTG_OrdenComisionServiciosHospedaje_Final.precioNoche.Value)
                            :   new SqlParameter("@precioNoche",  DBNull.Value),
                         mdl_CTG_OrdenComisionServiciosHospedaje_Final.fechaBorrado != null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTG_OrdenComisionServiciosHospedaje_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)
                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosHospedaje), mdl_CTG_OrdenComisionServiciosHospedaje_DatosViejos, mdl_CTG_OrdenComisionServiciosHospedaje_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Ver si existe ######################################################################
                CTG_OrdenComisionServiciosHospedaje mdl_CTG_OrdenComisionServiciosHospedaje_Final = Obtener_Modelo_Por_Id(_lng_id);
                //######################################################################################

                if (mdl_CTG_OrdenComisionServiciosHospedaje_Final != null)
                {
                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                                                " SET " +
                                                nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(CTG_OrdenComisionServiciosHospedaje.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@fechaBorrado",  DateTime.Now),
                        new SqlParameter("@id", _lng_id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Grabar un registro de trazabilidad con los datos de la transaccion realizada
                    Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTG_OrdenComisionServiciosHospedaje), null, mdl_CTG_OrdenComisionServiciosHospedaje_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                }

                //Devolver tambien el Objeto
                mdl_ValorDevuelto_Modelo.Id = _lng_id;
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                List<long> lst_idOrdenComisionServicioHospedaje = (List<long>)_mdl_obj;

                if (lst_idOrdenComisionServicioHospedaje != null & lst_idOrdenComisionServicioHospedaje.Count > 0)
                {
                    DateTime dtt_FechaActual = DateTime.Now;

                    //Coger los ids y ponerlos de forma que sirva para la consulta
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idOrdenComisionServicioHospedaje);

                    string str_SQL = " UPDATE " + nameof(CTG_OrdenComisionServiciosHospedaje) +
                                        " SET " + nameof(CTG_OrdenComisionServiciosHospedaje.fechaBorrado) + "='" + dtt_FechaActual + "' " +
                                     " WHERE " + nameof(CTG_OrdenComisionServiciosHospedaje.id) + " in (" + str_Filtros_IDS + ")";

                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL);
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTG_OrdenComisionServiciosHospedaje_Datos) + "/" + nameof(Borrar), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }

            return mdl_ValorDevuelto_Modelo;
        }
        #endregion

    }
}